{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: main.PAS, released on 18 July 2004.

The Initial Developer of the Original Code is Alexey Nikitayev [nikitayev@rsu.ru]
All Rights Reserved.

Contributor(s):

Last Modified: 18 July 2004

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:


-----------------------------------------------------------------------------}
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    GroupBox1: TGroupBox;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox: TDirectoryListBox;
    Button2: TButton;
    OpenDialog: TOpenDialog;
    Log: TMemo;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function ReadFromWpl (const FileName:string;var PlayList:TStringList):boolean;
    function ReadFromPls (const FileName:string;var PlayList:TStringList):boolean;
  end;

var
  Form1: TForm1;

implementation
uses INIFiles,About,StrUtils;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if (OpenDialog.Execute) then
    Edit1.Text:=OpenDialog.FileName;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i,count:integer;
  filename:string;
  fileext:string;
  ok:boolean;
  PlayList:TStringList;
  MP3FileName:string;
  NewFileName:string;
begin
  Log.Clear;
  Count:=0;
  if (FileExists(Edit1.Text)) then
  try
    Button2.Enabled:=false;
    Screen.Cursor:=crHourGlass;
    filename:=LowerCase(Edit1.Text);
    fileext:=ExtractFileExt(filename);
    ok:=false;
    if fileext='.wpl' then
      ok:=ReadFromWpl(filename,PlayList)
    else
      if fileext='.pls' then
        ok:=ReadFromPls(filename,PlayList);
    if not ok then
    begin
      Button2.Enabled:=true;
      Screen.Cursor:=crDefault;
      exit;
    end;
    for i:=0 to PlayList.Count-1 do
    begin
      MP3FileName:=PlayList[i];
      if (FileExists(MP3FileName)) then
      begin
        NewFileName:=DirectoryListBox.Directory+'\'+ExtractFileName(MP3FileName);
        if not (FileExists(NewFileName)) then
          CopyFile(PChar(MP3FileName),PChar(NewFileName),true);
        Inc(Count);
      end else
      begin
        Log.Lines.Add('Err: '+MP3FileName);
      end;
      Application.ProcessMessages;
    end;
    Log.Lines.Add(Format(' %d   %d',[Count,PlayList.Count]));
    FreeAndNil(PlayList);
  except
    on E:Exception do
    begin
      Log.Lines.Add(Format(' %d   %d',[Count,PlayList.Count]));
      Log.Lines.Add(E.Message);
      FreeAndNil(PlayList);
    end;
  end;
  Button2.Enabled:=true;
  Screen.Cursor:=crDefault;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Form2.Show;
end;

function TForm1.ReadFromPls(const FileName: string;
  var PlayList: TStringList): boolean;
var
  INI:TIniFile;
  i:Integer;
  MP3FileName:string;
begin
  result:=true;
  if not FileExists(FileName) then
  begin
    result:=false;
    exit;
  end;
  if PlayList<>nil then 
  try
    FreeAndNil(PlayList);
  except
    result:=false;
    exit;
  end;
  try
    INI:=TIniFile.Create(FileName);
  except
    FreeAndNil(INI);
    result:=false;
    exit;
  end;
  PlayList:=TStringList.Create;
  MP3FileName:=INI.ReadString('playlist','File1','');
  i:=1;
  while (MP3FileName<>'') do
  begin
    PlayList.Add(MP3FileName);
    inc(i);
    PlayList.Add(INI.ReadString('playlist',Format('File%d',[i]),''));
  end;
  FreeAndNil(INI);
end;

function TForm1.ReadFromWpl(const FileName:string;var PlayList:TStringList):boolean;
var
  s:TStringList;
  i:Integer;
  tmps:string;
  pos1,pos2:Integer;
begin
  result:=true;
  if not FileExists(FileName) then
  begin
    result:=false;
    exit;
  end;
  if PlayList<>nil then 
  try
    FreeAndNil(PlayList);
  except
    result:=false;
    exit;
  end;
  s:=TStringList.Create;
  try
    s.LoadFromFile(FileName);
  except
    FreeAndNil(s);
    result:=false;
    exit;
  end;
  PlayList:=TStringList.Create;
  for i:=0 to s.Count-1 do
  begin
    tmps:=s[i];
    pos1:=Pos('<media src="',tmps);
    if pos1<>0 then
    begin
      pos2:=PosEx('" tid="',tmps,pos1);
      PlayList.Add(copy(tmps,pos1+12,pos2-pos1-12));
    end;
  end;
  FreeAndNil(s);
end;

end.
